diff -crB mplp_ver2/mplp_alg.cpp mplp_ver2.src-patched/mplp_alg.cpp
*** mplp_ver2/mplp_alg.cpp	2012-08-08 20:25:06.000000000 +0200
--- mplp_ver2.src-patched/mplp_alg.cpp	2014-02-25 10:05:55.000000000 +0100
***************
*** 8,14 ****
   *
   */
  
- #include "mplp_alg.h"
  #include <iostream>
  #include <sstream>
  #include <stdlib.h>
--- 8,13 ----
***************
*** 18,24 ****
  #include <queue>
  #include <stack>
  
! #define DEBUG_MODE 1
  
  // Gap used within decoding algorithm. TODO: Better algorithm for choosing this (perhaps iteratively).
  #define GAP_THR .001
--- 17,27 ----
  #include <queue>
  #include <stack>
  
! #include "mplp_alg.h"
! 
! using namespace std;
! 
! #define MPLP_DEBUG_MODE 0
  
  // Gap used within decoding algorithm. TODO: Better algorithm for choosing this (perhaps iteratively).
  #define GAP_THR .001
***************
*** 27,43 ****
  // Code to implement the Region object.
  /////////////////////////////////////////////////////////////////////////////////////
  
! Region::Region(vector<int> & region_inds, vector<vector<int> > & all_intersects, vector<int> & intersect_inds, vector<int> & var_sizes, int region_intersect): m_region_inds(region_inds), m_intersect_inds(intersect_inds), m_region_intersect(region_intersect)
  {
  	// Find the indices of each intersection within the region. Also intialize the message into that intersection
! 	for (int si=0; si<m_intersect_inds.size(); ++si){
  		vector<int> tmp_inds_of_intersects;
  		
  		vector<int> curr_intersect = all_intersects[m_intersect_inds[si]];
  		
  		vector<int> intersect_var_sizes;
  		// Go over all variables in the intersection set
! 		for (int i=0; i< curr_intersect.size(); ++i){
  			int var_in_intersect = curr_intersect[i];
  			intersect_var_sizes.push_back(var_sizes[var_in_intersect]);
  			
--- 30,46 ----
  // Code to implement the Region object.
  /////////////////////////////////////////////////////////////////////////////////////
  
! Region::Region(const vector<int> & region_inds, const vector<vector<int> > & all_intersects, const vector<int> & intersect_inds, const vector<int> & var_sizes, int region_intersect): m_region_inds(region_inds), m_intersect_inds(intersect_inds), m_region_intersect(region_intersect)
  {
  	// Find the indices of each intersection within the region. Also intialize the message into that intersection
! 	for (size_t si=0; si<m_intersect_inds.size(); ++si){
  		vector<int> tmp_inds_of_intersects;
  		
  		vector<int> curr_intersect = all_intersects[m_intersect_inds[si]];
  		
  		vector<int> intersect_var_sizes;
  		// Go over all variables in the intersection set
! 		for (size_t i=0; i< curr_intersect.size(); ++i){
  			int var_in_intersect = curr_intersect[i];
  			intersect_var_sizes.push_back(var_sizes[var_in_intersect]);
  			
***************
*** 63,69 ****
  	}
  	// Calculate the size of the region state space (although this should already be in the lambda object, so we should
      // probably avoid this multiplicity)
! 	for (int i=0; i<region_inds.size(); ++i) {
  		m_var_sizes.push_back(var_sizes[region_inds[i]]);
  	}
  }
--- 66,72 ----
  	}
  	// Calculate the size of the region state space (although this should already be in the lambda object, so we should
      // probably avoid this multiplicity)
! 	for (size_t i=0; i<region_inds.size(); ++i) {
  		m_var_sizes.push_back(var_sizes[region_inds[i]]);
  	}
  }
***************
*** 74,80 ****
  	vector<int> curr_intersect = all_intersects[intersect_loc];
  
  	/*
! 	if(DEBUG_MODE) {
  	  for (int i=0; i< curr_intersect.size(); ++i){
  	    int var_in_intersect = curr_intersect[i];
  	    cout << "   " << var_in_intersect;
--- 77,83 ----
  	vector<int> curr_intersect = all_intersects[intersect_loc];
  
  	/*
! 	if(MPLP_DEBUG_MODE) {
  	  for (int i=0; i< curr_intersect.size(); ++i){
  	    int var_in_intersect = curr_intersect[i];
  	    cout << "   " << var_in_intersect;
***************
*** 85,91 ****
  		
  	vector<int> intersect_var_sizes;
  	// Go over all variables in the intersection set
! 	for (int i=0; i< curr_intersect.size(); ++i){
  		int var_in_intersect = curr_intersect[i];
  		intersect_var_sizes.push_back(var_sizes[var_in_intersect]);
  			
--- 88,94 ----
  		
  	vector<int> intersect_var_sizes;
  	// Go over all variables in the intersection set
! 	for (size_t i=0; i< curr_intersect.size(); ++i){
  		int var_in_intersect = curr_intersect[i];
  		intersect_var_sizes.push_back(var_sizes[var_in_intersect]);
  			
***************
*** 100,106 ****
  		}
  	}
  
! 	/*	if(DEBUG_MODE) {
  	  cout << "intersection locs: ";
  	  for(int i=0; i<tmp_inds_of_intersects.size(); i++) {
  	    
--- 103,109 ----
  		}
  	}
  
! 	/*	if(MPLP_DEBUG_MODE) {
  	  cout << "intersection locs: ";
  	  for(int i=0; i<tmp_inds_of_intersects.size(); i++) {
  	    
***************
*** 136,147 ****
  	*/
  	// Set this to be the region's intersection set value
  	MulDimArr orig(sum_into_intersects[m_region_intersect]);
! 	for (int si=0; si<m_intersect_inds.size(); ++si){
  	        // Take out previous message
  		vector<int> & curr_inds_of_intersect = m_inds_of_intersects[si];
  
  		/*
! 		if(DEBUG_MODE) {
  		  cout << "Intersection set { ";
  		  for(int i=0; i < curr_inds_of_intersect.size(); i++) {
  		    cout << curr_inds_of_intersect[i] << " ";
--- 139,150 ----
  	*/
  	// Set this to be the region's intersection set value
  	MulDimArr orig(sum_into_intersects[m_region_intersect]);
! 	for (size_t si=0; si<m_intersect_inds.size(); ++si){
  	        // Take out previous message
  		vector<int> & curr_inds_of_intersect = m_inds_of_intersects[si];
  
  		/*
! 		if(MPLP_DEBUG_MODE) {
  		  cout << "Intersection set { ";
  		  for(int i=0; i < curr_inds_of_intersect.size(); i++) {
  		    cout << curr_inds_of_intersect[i] << " ";
***************
*** 154,160 ****
  	}
  	// Will store the total messages going into the intersection, but not from the Region
  	vector<MulDimArr> lam_minus_region;
! 	for (int si=0; si<m_intersect_inds.size(); ++si){
  		int curr_intersect = m_intersect_inds[si];
  
  		lam_minus_region.push_back(MulDimArr());
--- 157,163 ----
  	}
  	// Will store the total messages going into the intersection, but not from the Region
  	vector<MulDimArr> lam_minus_region;
! 	for (size_t si=0; si<m_intersect_inds.size(); ++si){
  		int curr_intersect = m_intersect_inds[si];
  
  		lam_minus_region.push_back(MulDimArr());
***************
*** 174,180 ****
  	// Update messages
  	sum_into_intersects[m_region_intersect].max_into_multiple_subsets_special(m_inds_of_intersects,m_msgs_from_region); // sets m_msgs_from_region
  	int sC = m_intersect_inds.size();
! 	for (int si=0; si<m_intersect_inds.size(); ++si){
  		// Take out previous message
  		int curr_intersect = m_intersect_inds[si];
  		// Update message
--- 177,183 ----
  	// Update messages
  	sum_into_intersects[m_region_intersect].max_into_multiple_subsets_special(m_inds_of_intersects,m_msgs_from_region); // sets m_msgs_from_region
  	int sC = m_intersect_inds.size();
! 	for (size_t si=0; si<m_intersect_inds.size(); ++si){
  		// Take out previous message
  		int curr_intersect = m_intersect_inds[si];
  		// Update message
***************
*** 196,202 ****
  // Code to read in factor graph and initialize MPLP.
  ////////////////////////////////////////////////////////////////////////////////
  
! MPLPAlg::MPLPAlg(clock_t start, int time_limit, const std::string model_file, const std::string evid_file, FILE *log_file, bool uaiCompetition) : start(start), time_limit(time_limit), begin(false), m_best_val(-huge), last_obj(huge), total_mplp_iterations(0), previous_run_of_global_decoding(-1), obj_del(huge), _log_file(log_file), m_uaiCompetition(uaiCompetition) {
  
  	size_t n;
  	_res_fname = model_file.substr( (n = model_file.find_last_of('/')) == std::string::npos ? 0 : n + 1 ).append(".MPE");
--- 199,205 ----
  // Code to read in factor graph and initialize MPLP.
  ////////////////////////////////////////////////////////////////////////////////
  
! MPLPAlg::MPLPAlg(clock_t start, int time_limit, const std::string model_file, const std::string evid_file, FILE *log_file, bool uaiCompetition) : begin(false), m_best_val(-huge), last_obj(huge), obj_del(huge), total_mplp_iterations(0), previous_run_of_global_decoding(-1), m_uaiCompetition(uaiCompetition), _log_file(log_file), start(start), time_limit(time_limit) {
  
  	size_t n;
  	_res_fname = model_file.substr( (n = model_file.find_last_of('/')) == std::string::npos ? 0 : n + 1 ).append(".MPE");
***************
*** 219,226 ****
  	}
  }
  
  void MPLPAlg::Init(const std::string fn, const std::string evid_fn){
! 	if(DEBUG_MODE)
  	  cout << "Calling Init() code...\n";
  
  	std::vector<int> var_sizes;
--- 222,236 ----
  	}
  }
  
+ MPLPAlg::MPLPAlg(clock_t start, int time_limit, const std::vector<int>& var_sizes, const std::vector< std::vector<int> >& all_factors, const std::vector< std::vector<double> >& all_lambdas, FILE *log_file, bool uaiCompetition) : begin(false), m_best_val(-huge), last_obj(huge), obj_del(huge), total_mplp_iterations(0), previous_run_of_global_decoding(-1), m_uaiCompetition(uaiCompetition), _res_fname("MPLP_Results.log"), _ofs_res(_res_fname.c_str(), std::ios::out | std::ios::trunc), _log_file(log_file), start(start), time_limit(time_limit) {
+    if(MPLP_DEBUG_MODE) std::cout<<"Initializing..."<<std::endl;
+ 
+    Init(var_sizes, all_factors, all_lambdas);
+ 
+ }
+ 
  void MPLPAlg::Init(const std::string fn, const std::string evid_fn){
! 	if(MPLP_DEBUG_MODE)
  	  cout << "Calling Init() code...\n";
  
  	std::vector<int> var_sizes;
***************
*** 235,241 ****
  }
  
  void MPLPAlg::Init2(const std::string fn, const std::string evid_fn){
! 	if(DEBUG_MODE)
  	  cout << "Calling Init2() code...\n";
  
  	std::vector<int> var_sizes;
--- 245,251 ----
  }
  
  void MPLPAlg::Init2(const std::string fn, const std::string evid_fn){
! 	if(MPLP_DEBUG_MODE)
  	  cout << "Calling Init2() code...\n";
  
  	std::vector<int> var_sizes;
***************
*** 249,255 ****
  }
  
  
! void MPLPAlg::Init(vector<int> & var_sizes, vector<vector<int> > & all_region_inds, vector<vector<double> > & all_lambdas) {
          // Set m_var_sizes
  	m_var_sizes = var_sizes;   //invoking copy constructor
  
--- 259,265 ----
  }
  
  
! void MPLPAlg::Init(const vector<int> & var_sizes, const vector<vector<int> > & all_region_inds, const vector<vector<double> > & all_lambdas) {
          // Set m_var_sizes
  	m_var_sizes = var_sizes;   //invoking copy constructor
  
***************
*** 257,263 ****
  	// Initialize sum into intersections.
  
  	// First, add all individual nodes as their own intersection set
! 	for(int si=0; si < m_var_sizes.size(); ++si) {
  		m_all_intersects.push_back(vector<int>(1,si));
  		vector<int> subset_size(1,m_var_sizes[si]);    // Initialize sum into intersections to zero for these
  		m_sum_into_intersects.push_back(MulDimArr(subset_size) = 0);
--- 267,273 ----
  	// Initialize sum into intersections.
  
  	// First, add all individual nodes as their own intersection set
! 	for(size_t si=0; si < m_var_sizes.size(); ++si) {
  		m_all_intersects.push_back(vector<int>(1,si));
  		vector<int> subset_size(1,m_var_sizes[si]);    // Initialize sum into intersections to zero for these
  		m_sum_into_intersects.push_back(MulDimArr(subset_size) = 0);
***************
*** 266,279 ****
  
  	// Next initialize all regions. If not a single node, give them their own intersection set
  
! 	for (int ri=0; ri < all_region_inds.size(); ++ri) {
  		//vector<int> *region_var_sizes = new vector<int>();
  		vector<int> region_var_sizes;
! 		for (int i=0; i < all_region_inds[ri].size(); ++i){
  			region_var_sizes.push_back(m_var_sizes[all_region_inds[ri][i]]);
  		}
  
! 		/*		if(DEBUG_MODE) {
  		  if(all_region_inds[ri].size() == 0) {
  		    cout << "Length zero region!" << endl;
  		  }
--- 276,289 ----
  
  	// Next initialize all regions. If not a single node, give them their own intersection set
  
! 	for (size_t ri=0; ri < all_region_inds.size(); ++ri) {
  		//vector<int> *region_var_sizes = new vector<int>();
  		vector<int> region_var_sizes;
! 		for (size_t i=0; i < all_region_inds[ri].size(); ++i){
  			region_var_sizes.push_back(m_var_sizes[all_region_inds[ri][i]]);
  		}
  
! 		/*		if(MPLP_DEBUG_MODE) {
  		  if(all_region_inds[ri].size() == 0) {
  		    cout << "Length zero region!" << endl;
  		  }
***************
*** 321,327 ****
  	}
  
  	// Initialize output vector
! 	for (int i=0; i<m_var_sizes.size(); ++i){
      		m_decoded_res.push_back(0);
  		m_best_decoded_res.push_back(0);
  	}
--- 331,337 ----
  	}
  
  	// Initialize output vector
! 	for (size_t i=0; i<m_var_sizes.size(); ++i){
      		m_decoded_res.push_back(0);
  		m_best_decoded_res.push_back(0);
  	}
***************
*** 345,351 ****
  
  	    // Check to see if fields
  	    bool isCSP = true;
! 	    for(int si=0; si < m_var_sizes.size(); ++si) {
  	      for(int loc=0; loc < m_sum_into_intersects[si].m_n_prodsize; loc++) {
  		if(m_sum_into_intersects[si].m_dat[loc] != 0) {
  		  isCSP = false;
--- 355,361 ----
  
  	    // Check to see if fields
  	    bool isCSP = true;
! 	    for(size_t si=0; si < m_var_sizes.size(); ++si) {
  	      for(int loc=0; loc < m_sum_into_intersects[si].m_n_prodsize; loc++) {
  		if(m_sum_into_intersects[si].m_dat[loc] != 0) {
  		  isCSP = false;
***************
*** 356,365 ****
  	    }
  	    
  	    if(isCSP) {
! 	      if(DEBUG_MODE) cout << "Likely CSP instance. Randomly perturbing objective." << endl;
  	      CSP_instance = true;
  
! 	      for(int si=0; si < m_var_sizes.size(); ++si) {
  		// Randomly perturb 
  		for(int loc=0; loc < m_sum_into_intersects[si].m_n_prodsize; loc++) {
  		  // TODO: how to set the scale?
--- 366,375 ----
  	    }
  	    
  	    if(isCSP) {
! 	      if(MPLP_DEBUG_MODE) cout << "Likely CSP instance. Randomly perturbing objective." << endl;
  	      CSP_instance = true;
  
! 	      for(size_t si=0; si < m_var_sizes.size(); ++si) {
  		// Randomly perturb 
  		for(int loc=0; loc < m_sum_into_intersects[si].m_n_prodsize; loc++) {
  		  // TODO: how to set the scale?
***************
*** 380,386 ****
  ////////////////////////////////////////////////////////////////////////////////
  
  void MPLPAlg::RunMPLP(int niter, double obj_del_thr, double int_gap_thr){
! 	int ri;
  	
  	// Perform the GMPLP updates (Sontag's modified version), not quite as in the GJ NIPS07 paper
  	for (int it=0; it<niter; ++it){
--- 390,396 ----
  ////////////////////////////////////////////////////////////////////////////////
  
  void MPLPAlg::RunMPLP(int niter, double obj_del_thr, double int_gap_thr){
!    size_t ri;
  	
  	// Perform the GMPLP updates (Sontag's modified version), not quite as in the GJ NIPS07 paper
  	for (int it=0; it<niter; ++it){
***************
*** 400,413 ****
  		// Run global decoding at least once, a third of the way through
  		if(previous_run_of_global_decoding == -1 &&
  		   ((double)(clock() - start) / CLOCKS_PER_SEC) > time_limit/3) {
! 		  if(DEBUG_MODE)
  		    cout << "Third of the way! Going to run global decoding once." << endl;
  		  RunGlobalDecoding(false);
  		}
  
  		int_gap = obj - m_best_val;
  
! 		if (DEBUG_MODE){
  			cout << "Iter=" << (it+1) << " Objective=" << obj <<  " Decoded=" << m_best_val << " ObjDel=" <<  obj_del << " IntGap=" << int_gap << endl;
  		}
  		if(_log_file != 0){
--- 410,423 ----
  		// Run global decoding at least once, a third of the way through
  		if(previous_run_of_global_decoding == -1 &&
  		   ((double)(clock() - start) / CLOCKS_PER_SEC) > time_limit/3) {
! 		  if(MPLP_DEBUG_MODE)
  		    cout << "Third of the way! Going to run global decoding once." << endl;
  		  RunGlobalDecoding(false);
  		}
  
  		int_gap = obj - m_best_val;
  
! 		if (MPLP_DEBUG_MODE){
  			cout << "Iter=" << (it+1) << " Objective=" << obj <<  " Decoded=" << m_best_val << " ObjDel=" <<  obj_del << " IntGap=" << int_gap << endl;
  		}
  		if(_log_file != 0){
***************
*** 425,443 ****
  void MPLPAlg::AddAllEdgeIntersections()
  {
  
!   if(DEBUG_MODE) cout << "Adding all edge intersection sets..." << endl;
  
    // Iterate over all of the regions
!   for (int ri=0; ri<m_all_regions.size(); ++ri){
      
      // We only care about the regions with >2 variables
      if(m_all_regions[ri].m_region_inds.size() <= 2) continue;
  
      // For each pair of the variables, add the corresponding intersection set
!     for(int vi=0; vi < m_all_regions[ri].m_region_inds.size()-1; vi++) {
        int i = m_all_regions[ri].m_region_inds[vi];
  
!       for(int vj= vi + 1; vj < m_all_regions[ri].m_region_inds.size(); vj++) {
  	int j = m_all_regions[ri].m_region_inds[vj];
  
  	// Find or add intersection set to the objective
--- 435,453 ----
  void MPLPAlg::AddAllEdgeIntersections()
  {
  
!   if(MPLP_DEBUG_MODE) cout << "Adding all edge intersection sets..." << endl;
  
    // Iterate over all of the regions
!   for (size_t ri=0; ri<m_all_regions.size(); ++ri){
      
      // We only care about the regions with >2 variables
      if(m_all_regions[ri].m_region_inds.size() <= 2) continue;
  
      // For each pair of the variables, add the corresponding intersection set
!     for(size_t vi=0; vi < m_all_regions[ri].m_region_inds.size()-1; vi++) {
        int i = m_all_regions[ri].m_region_inds[vi];
  
!       for(size_t vj= vi + 1; vj < m_all_regions[ri].m_region_inds.size(); vj++) {
  	int j = m_all_regions[ri].m_region_inds[vj];
  
  	// Find or add intersection set to the objective
***************
*** 479,485 ****
  	m_all_intersects.push_back(inds_of_vars);
  	// Calculate the sizes of the variables in this set
  	vector<int> sizes;
! 	for (int i=0; i< inds_of_vars.size(); ++i)
  		sizes.push_back(m_var_sizes[inds_of_vars[i]]);
  
  	// If this is an edge, insert into the map
--- 489,495 ----
  	m_all_intersects.push_back(inds_of_vars);
  	// Calculate the sizes of the variables in this set
  	vector<int> sizes;
! 	for (size_t i=0; i< inds_of_vars.size(); ++i)
  		sizes.push_back(m_var_sizes[inds_of_vars[i]]);
  
  	// If this is an edge, insert into the map
***************
*** 489,495 ****
  		vector<int> tmp_inds(inds_of_vars);
  		sort(tmp_inds.begin(), tmp_inds.end());
  
! 		//		if(DEBUG_MODE)
  		//		  cout << "adding edge intersection set " << tmp_inds[0] << " " << tmp_inds[1] << endl;
  
  		// Then insert
--- 499,505 ----
  		vector<int> tmp_inds(inds_of_vars);
  		sort(tmp_inds.begin(), tmp_inds.end());
  
! 		//		if(MPLP_DEBUG_MODE)
  		//		  cout << "adding edge intersection set " << tmp_inds[0] << " " << tmp_inds[1] << endl;
  
  		// Then insert
***************
*** 522,528 ****
  		}
  	}
  
! 	for(int i=0; i < m_all_intersects.size(); ++i)
  	{
  		// copy, then sort
  		vector<int> tmp_inds(m_all_intersects[i]);
--- 532,538 ----
  		}
  	}
  
! 	for(size_t i=0; i < m_all_intersects.size(); ++i)
  	{
  		// copy, then sort
  		vector<int> tmp_inds(m_all_intersects[i]);
***************
*** 537,553 ****
  
  double MPLPAlg::IntVal(vector<int> & assignment) const{
  	double int_val = 0;
! 	for (int ri=0; ri<m_all_regions.size(); ++ri){
  		if (m_region_lambdas[ri].m_n_prodsize){
  			vector<int> tmpvec;
! 			for (int vi = 0; vi < m_all_regions[ri].m_region_inds.size(); ++vi){
  				tmpvec.push_back(assignment[m_all_regions[ri].m_region_inds[vi]]);
  			}
  			int_val+= m_region_lambdas[ri].GetVal(tmpvec);
  		}
  	}
  	//This iterates over all singletons
! 	for (int ni=0; ni<m_var_sizes.size(); ++ni){
  		int_val+=m_single_node_lambdas[ni][assignment[ni]];
  	}
  	return int_val;
--- 547,563 ----
  
  double MPLPAlg::IntVal(vector<int> & assignment) const{
  	double int_val = 0;
! 	for (size_t ri=0; ri<m_all_regions.size(); ++ri){
  		if (m_region_lambdas[ri].m_n_prodsize){
  			vector<int> tmpvec;
! 			for (size_t vi = 0; vi < m_all_regions[ri].m_region_inds.size(); ++vi){
  				tmpvec.push_back(assignment[m_all_regions[ri].m_region_inds[vi]]);
  			}
  			int_val+= m_region_lambdas[ri].GetVal(tmpvec);
  		}
  	}
  	//This iterates over all singletons
! 	for (size_t ni=0; ni<m_var_sizes.size(); ++ni){
  		int_val+=m_single_node_lambdas[ni][assignment[ni]];
  	}
  	return int_val;
***************
*** 556,562 ****
  double MPLPAlg::LocalDecode(void){
  	double obj=0;
  	int max_at;
! 	for (int si=0; si<m_sum_into_intersects.size(); ++si){
  		obj+= m_sum_into_intersects[si].Max(max_at);
  		// If this is a singleton, keep its value (so that we also have an integral assignment). 
  		// NOTE: Here we assume that all singletons are intersection sets. Otherwise, some variables will not be decoded here
--- 566,572 ----
  double MPLPAlg::LocalDecode(void){
  	double obj=0;
  	int max_at;
! 	for (size_t si=0; si<m_sum_into_intersects.size(); ++si){
  		obj+= m_sum_into_intersects[si].Max(max_at);
  		// If this is a singleton, keep its value (so that we also have an integral assignment). 
  		// NOTE: Here we assume that all singletons are intersection sets. Otherwise, some variables will not be decoded here
***************
*** 578,584 ****
  	double int_val;
  	if ( (int_val = IntVal(m_decoded_res)) > m_best_val){
  
! 	  if(DEBUG_MODE) 
  	    cout << "int val: " << int_val << endl;
  
  		if (time_limit + (double)(start - clock()) / CLOCKS_PER_SEC > MIN_APP_TIME){ // Prevent a partial write
--- 588,594 ----
  	double int_val;
  	if ( (int_val = IntVal(m_decoded_res)) > m_best_val){
  
! 	  if(MPLP_DEBUG_MODE)
  	    cout << "int val: " << int_val << endl;
  
  		if (time_limit + (double)(start - clock()) / CLOCKS_PER_SEC > MIN_APP_TIME){ // Prevent a partial write
***************
*** 607,613 ****
  	//"This will be the number of lines (not include this line) in the solution part."
  	s << "1" << "\n" << m_var_sizes.size() << " ";
  
! 	for (int vi=0; vi< m_var_sizes.size()-1; ++vi){
  		s << m_decoded_res[vi] << " ";
  	}
  
--- 617,623 ----
  	//"This will be the number of lines (not include this line) in the solution part."
  	s << "1" << "\n" << m_var_sizes.size() << " ";
  
! 	for (size_t vi=0; vi< m_var_sizes.size()-1; ++vi){
  		s << m_decoded_res[vi] << " ";
  	}
  
***************
*** 631,644 ****
  
  void MPLPAlg::RunGlobalDecoding(bool exhaustive){
  
!   if(DEBUG_MODE) {
      cout << "Running global decoding..." << endl;
    }
  
    std::set<int> not_decoded;
    double global_decoding_start_time = (double)clock();
  
-   int m, i, j, k;
  	std::vector< std::vector< std::vector<double> > > tmp_msgs;
  	std::vector< std::vector<double> > tmp_sums;
  	std::map<int, int> tmp_evid = evidence;//, max_at;
--- 641,653 ----
  
  void MPLPAlg::RunGlobalDecoding(bool exhaustive){
  
!   if(MPLP_DEBUG_MODE) {
      cout << "Running global decoding..." << endl;
    }
  
    std::set<int> not_decoded;
    double global_decoding_start_time = (double)clock();
  
  	std::vector< std::vector< std::vector<double> > > tmp_msgs;
  	std::vector< std::vector<double> > tmp_sums;
  	std::map<int, int> tmp_evid = evidence;//, max_at;
***************
*** 648,672 ****
  
  	int num_mplp_iters_global_decoding = 0;
  
! 	for (i = 0; i < m_all_regions.size(); ++i){
  		tmp_msgs.push_back(std::vector< std::vector<double> >());
! 		for (j = 0; j < m_all_regions[i].m_msgs_from_region.size(); ++j){
  			tmp_msgs[i].push_back(std::vector<double>());
! 			for (k = 0; k < m_all_regions[i].m_msgs_from_region[j].m_n_prodsize; ++k){
  				tmp_msgs[i][j].push_back(m_all_regions[i].m_msgs_from_region[j].m_dat[k]);
  			}
  		}
  	}
  
! 	for (i = 0; i < m_sum_into_intersects.size(); ++i){
  		tmp_sums.push_back(std::vector<double>());
! 		for (j = 0; j < m_sum_into_intersects[i].m_n_prodsize; ++j){
  			tmp_sums[i].push_back(m_sum_into_intersects[i].m_dat[j]);
  		}
  	}
  
  	// Initialize all variables as not yet decoded
! 	for (i = 0; i < m_var_sizes.size(); ++i){
  		if (evidence.find(i) == evidence.end()){
  			not_decoded.insert(i);
  		}
--- 657,681 ----
  
  	int num_mplp_iters_global_decoding = 0;
  
! 	for (size_t i = 0; i < m_all_regions.size(); ++i){
  		tmp_msgs.push_back(std::vector< std::vector<double> >());
! 		for (size_t j = 0; j < m_all_regions[i].m_msgs_from_region.size(); ++j){
  			tmp_msgs[i].push_back(std::vector<double>());
! 			for (int k = 0; k < m_all_regions[i].m_msgs_from_region[j].m_n_prodsize; ++k){
  				tmp_msgs[i][j].push_back(m_all_regions[i].m_msgs_from_region[j].m_dat[k]);
  			}
  		}
  	}
  
! 	for (size_t i = 0; i < m_sum_into_intersects.size(); ++i){
  		tmp_sums.push_back(std::vector<double>());
! 		for (int j = 0; j < m_sum_into_intersects[i].m_n_prodsize; ++j){
  			tmp_sums[i].push_back(m_sum_into_intersects[i].m_dat[j]);
  		}
  	}
  
  	// Initialize all variables as not yet decoded
! 	for (size_t i = 0; i < m_var_sizes.size(); ++i){
  		if (evidence.find(i) == evidence.end()){
  			not_decoded.insert(i);
  		}
***************
*** 675,680 ****
--- 684,690 ----
  	while (!not_decoded.empty()){
  		double biggest_gap = -huge;
  		for (std::set<int>::iterator s_it = not_decoded.begin(); s_it != not_decoded.end(); ++s_it){
+ 		   int m;
  			if( ( gap_vals[*s_it] = gap(*s_it, m) ) >= biggest_gap)
  				biggest_gap = gap_vals[*s_it];
  			max_at[*s_it] = m;
***************
*** 685,691 ****
  		else
  		  biggest_gap /= 10;
  
! 		if(DEBUG_MODE){
  		  cout << "biggest gap now set to " << biggest_gap << ", remaining nodes = " << not_decoded.size() << ", new int sol = " << m_best_val << endl;
  		}
  		
--- 695,701 ----
  		else
  		  biggest_gap /= 10;
  
! 		if(MPLP_DEBUG_MODE){
  		  cout << "biggest gap now set to " << biggest_gap << ", remaining nodes = " << not_decoded.size() << ", new int sol = " << m_best_val << endl;
  		}
  		
***************
*** 697,703 ****
  
  				m_decoded_res[*s_it] = max_at[*s_it];
  				not_decoded.erase(*s_it);
! 
  				for (i = 0; i < max_at[*s_it]; ++i){
  					m_sum_into_intersects[*s_it][i] = -huge;
  				}
--- 707,713 ----
  
  				m_decoded_res[*s_it] = max_at[*s_it];
  				not_decoded.erase(*s_it);
! 				int i;
  				for (i = 0; i < max_at[*s_it]; ++i){
  					m_sum_into_intersects[*s_it][i] = -huge;
  				}
***************
*** 710,717 ****
  		  }
  		}
  
! 		for (int it=0; it<10; ++it){
! 			for (int ri=0; ri<m_all_regions.size(); ++ri){
  				m_all_regions[ri].UpdateMsgs(m_sum_into_intersects);
  			}
  			num_mplp_iters_global_decoding++;
--- 720,727 ----
  		  }
  		}
  
! 		for (size_t it=0; it<10; ++it){
! 			for (size_t ri=0; ri<m_all_regions.size(); ++ri){
  				m_all_regions[ri].UpdateMsgs(m_sum_into_intersects);
  			}
  			num_mplp_iters_global_decoding++;
***************
*** 726,740 ****
  		//		  break;
  	}
  
! 	for (i = 0; i < m_all_regions.size(); ++i){
! 		for (j = 0; j < m_all_regions[i].m_msgs_from_region.size(); ++j){
! 		  for (k = 0; k < m_all_regions[i].m_msgs_from_region[j].m_n_prodsize; ++k){
  				m_all_regions[i].m_msgs_from_region[j].m_dat[k] = tmp_msgs[i][j][k];
  			}
  		}
  	}
! 	for (i = 0; i < m_sum_into_intersects.size(); ++i){
! 		for (j = 0; j < m_sum_into_intersects[i].m_n_prodsize; ++j){
  			m_sum_into_intersects[i].m_dat[j] = tmp_sums[i][j];
  		}
  	}
--- 736,750 ----
  		//		  break;
  	}
  
! 	for (size_t i = 0; i < m_all_regions.size(); ++i){
! 		for (size_t j = 0; j < m_all_regions[i].m_msgs_from_region.size(); ++j){
! 		  for (int k = 0; k < m_all_regions[i].m_msgs_from_region[j].m_n_prodsize; ++k){
  				m_all_regions[i].m_msgs_from_region[j].m_dat[k] = tmp_msgs[i][j][k];
  			}
  		}
  	}
! 	for (size_t i = 0; i < m_sum_into_intersects.size(); ++i){
! 		for (int j = 0; j < m_sum_into_intersects[i].m_n_prodsize; ++j){
  			m_sum_into_intersects[i].m_dat[j] = tmp_sums[i][j];
  		}
  	}
***************
*** 751,764 ****
  //note: sorting gap values in ascending order and fixing the node with lowest gap value first (to resolve possible frustration)
  // TODO: put some randomness into this! Of all tied states, randomly sample. Or, randomly permute tied nodes, then choose 1. Or both.
  void MPLPAlg::RunGlobalDecoding2(bool exhaustive){
! 	if(DEBUG_MODE) {
  		cout << "Running global decoding2..." << endl;
  	}
  
  	std::set<int> not_decoded;
  	double global_decoding_start_time = (double)clock();
  
- 	int m, i, j;
  	std::vector< std::vector< std::vector<double> > > tmp_msgs;
  	std::vector< std::vector<double> > tmp_sums;
  	std::map<int, int> tmp_evid = evidence;//, max_at;
--- 761,773 ----
  //note: sorting gap values in ascending order and fixing the node with lowest gap value first (to resolve possible frustration)
  // TODO: put some randomness into this! Of all tied states, randomly sample. Or, randomly permute tied nodes, then choose 1. Or both.
  void MPLPAlg::RunGlobalDecoding2(bool exhaustive){
! 	if(MPLP_DEBUG_MODE) {
  		cout << "Running global decoding2..." << endl;
  	}
  
  	std::set<int> not_decoded;
  	double global_decoding_start_time = (double)clock();
  
  	std::vector< std::vector< std::vector<double> > > tmp_msgs;
  	std::vector< std::vector<double> > tmp_sums;
  	std::map<int, int> tmp_evid = evidence;//, max_at;
***************
*** 768,776 ****
  	int num_mplp_iters_global_decoding = 0;
  
  	//saving current mplp state
! 	for (i = 0; i < m_all_regions.size(); ++i){
  		tmp_msgs.push_back(std::vector< std::vector<double> >());
! 		for (j = 0; j < m_all_regions[i].m_msgs_from_region.size(); ++j){
  			tmp_msgs[i].push_back(std::vector<double>());
  			for (int k = 0; k < m_all_regions[i].m_msgs_from_region[j].m_n_prodsize; ++k){
  				tmp_msgs[i][j].push_back(m_all_regions[i].m_msgs_from_region[j].m_dat[k]);
--- 777,785 ----
  	int num_mplp_iters_global_decoding = 0;
  
  	//saving current mplp state
! 	for (size_t i = 0; i < m_all_regions.size(); ++i){
  		tmp_msgs.push_back(std::vector< std::vector<double> >());
! 		for (size_t j = 0; j < m_all_regions[i].m_msgs_from_region.size(); ++j){
  			tmp_msgs[i].push_back(std::vector<double>());
  			for (int k = 0; k < m_all_regions[i].m_msgs_from_region[j].m_n_prodsize; ++k){
  				tmp_msgs[i][j].push_back(m_all_regions[i].m_msgs_from_region[j].m_dat[k]);
***************
*** 778,792 ****
  		}
  	}
  
! 	for (i = 0; i < m_sum_into_intersects.size(); ++i){
  		tmp_sums.push_back(std::vector<double>());
! 		for (j = 0; j < m_sum_into_intersects[i].m_n_prodsize; ++j){
  			tmp_sums[i].push_back(m_sum_into_intersects[i].m_dat[j]);
  		}
  	}
  
  	// find all variables that are not yet decoded
! 	for (int i = 0; i < m_var_sizes.size(); ++i){
  		if (evidence.find(i) == evidence.end()){
  			not_decoded.insert(i);
  		}
--- 787,801 ----
  		}
  	}
  
! 	for (size_t i = 0; i < m_sum_into_intersects.size(); ++i){
  		tmp_sums.push_back(std::vector<double>());
! 		for (int j = 0; j < m_sum_into_intersects[i].m_n_prodsize; ++j){
  			tmp_sums[i].push_back(m_sum_into_intersects[i].m_dat[j]);
  		}
  	}
  
  	// find all variables that are not yet decoded
! 	for (size_t i = 0; i < m_var_sizes.size(); ++i){
  		if (evidence.find(i) == evidence.end()){
  			not_decoded.insert(i);
  		}
